{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.QuickSight.Types.Edition
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.QuickSight.Types.Edition
  ( Edition
      ( ..,
        Edition_ENTERPRISE,
        Edition_ENTERPRISE_AND_Q,
        Edition_STANDARD
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype Edition = Edition' {fromEdition :: Data.Text}
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern Edition_ENTERPRISE :: Edition
pattern Edition_ENTERPRISE = Edition' "ENTERPRISE"

pattern Edition_ENTERPRISE_AND_Q :: Edition
pattern Edition_ENTERPRISE_AND_Q = Edition' "ENTERPRISE_AND_Q"

pattern Edition_STANDARD :: Edition
pattern Edition_STANDARD = Edition' "STANDARD"

{-# COMPLETE
  Edition_ENTERPRISE,
  Edition_ENTERPRISE_AND_Q,
  Edition_STANDARD,
  Edition'
  #-}
